﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace STSdb.MTL
{
    public interface ITransactable
    {
        void Commit();
        void RollBack();
       
        void TransactionIsFinished(int transactionThreadId);

        void SnapshotReadLocator(long transactionId);
        void RestoreLocatorsFromSnapshot(long transactionId);
        //void InitCreateLocators();

        /// <summary>
        /// Must return WRITE TABLE Locator
        /// </summary>
        STSdb.Data.ITransaction STSdbITransaction { get; }
        string TableName { get; }
    }
}
