﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using STSdb.General.Collections;

namespace STSdb.Persist
{
    public class PrimitiveByteIndexerPersist : IIndexerPersist<Byte>
    {
        public void Store(BinaryWriter writer, IIndexer<byte> values)
        {
            for (int i = 0; i < values.Count; i++)
                writer.Write(values[i]);
        }

        public void Load(BinaryReader reader, IIndexer<byte> values)
        {
            for (int i = 0; i < values.Count; i++)
                values[i] = reader.ReadByte();
        }
    }
}
