﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using STSdb.General.Collections;

namespace STSdb.Persist
{
    public class StringIndexerPersist : IIndexerPersist<String>
    {
        public readonly DeflateIndexerPersist<String> deflate = new DeflateIndexerPersist<string>(new PrimitiveStringIndexerPersist());
        
        public void Store(BinaryWriter writer, IIndexer<string> values)
        {
            deflate.Store(writer, values);
        }

        public void Load(BinaryReader reader, IIndexer<string> values)
        {
            deflate.Load(reader, values);
        }
    }
}
