﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using STSdb.General.Collections;

namespace STSdb.Persist
{
    public class PrimitiveInt64IndexerPersist : IIndexerPersist<Int64>
    {
        public void Store(BinaryWriter writer, IIndexer<long> values)
        {
            for (int i = 0; i < values.Count; i++)
                writer.Write(values[i]);
        }

        public void Load(BinaryReader reader, IIndexer<long> values)
        {
            for (int i = 0; i < values.Count; i++)
                values[i] = reader.ReadInt64();
        }
    }
}
