﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using STSdb.General.Collections;

namespace STSdb.Persist
{
    public class PrimitiveTimeSpanIndexerPersist : IIndexerPersist<TimeSpan>
    {
        public void Store(BinaryWriter writer, IIndexer<TimeSpan> values)
        {
            for (int i = 0; i < values.Count; i++)
                writer.Write(values[i].Ticks);
        }

        public void Load(BinaryReader reader, IIndexer<TimeSpan> values)
        {
            for (int i = 0; i < values.Count; i++)
                values[i] = new TimeSpan(reader.ReadInt64());
        }
    }
}
